// Written by TeTeT
// a simple experiment with BIS_fnc_findSafePos

if (!isServer) exitWith {};

ttt_bases = [BaseAirport, BaseBay, BaseConstruction, BaseHillTop, BaseMeadows, BasePort, BaseRiver, BaseStadium, BaseVilla, BaseDryDock, BaseNaval];
ttt_villages = [VillageDowntown];
ttt_callsigns = ["Bender", "Belorus", "Vorobey", "Zritel", "Kazak", "Kremen", "Polyarnik", "Medved", "Prorab", "Varona", "Foma", "Hohol", "Yakut", "Kopeika", "Drovosek", "Shaha", "Dispetcher", "Povar", "Zayac"];
ttt_spawnPoints = [ SpawnNorth, SpawnWest, SpawnSouth, SpawnEast ];


ttt_fnc_createPassengers = {
	params ["_pos", "_heli"];
	private _crewCount = count (crew _heli);
	private _allSeats = count (fullCrew [_heli, "", true]);
	private _openSeats = _allSeats - _crewCount;
	private _grp = createGroup east;

	if (_openSeats < 4) then {
		_grp = [_pos] call ttt_fnc_createOfficer;
	} else {
		if (_openSeats < 10) then {
			private _create = selectRandom [ttt_fnc_createOfficer, ttt_fnc_createTeam];
			_grp = [_pos] call _create;
		} else {
			private _create = selectRandom [ttt_fnc_createOfficer, ttt_fnc_createTeam, ttt_fnc_createSquad];
			_grp = [_pos] call _create;
		};
	};
	_grp;
};

ttt_fnc_createOfficer = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup east;
	"rhs_vmf_flora_officer" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_createTeam = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup east;
	"rhs_mvd_izlom_sergeant" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman_LAT" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman_asval" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_createSquad = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup east;
	"rhs_mvd_izlom_sergeant" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman_LAT" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman" createUnit [_pos, _grp];
	"rhs_mvd_izlom_arifleman" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman" createUnit [_pos, _grp];
	// "rhs_mvd_izlom_rifleman" createUnit [_pos, _grp];
	// "rhs_mvd_izlom_rifleman" createUnit [_pos, _grp];
	// "rhs_mvd_izlom_rifleman_asval" createUnit [_pos, _grp];
	// "rhs_mvd_izlom_rifleman" createUnit [_pos, _grp];
	// "rhs_mvd_izlom_grenadier_rpg" createUnit [_pos, _grp];
	private _ldr = leader _grp;
	private _pos = [getPos _ldr, 10, 30] call BIS_fnc_findSafePos;
	_ldr setPos _pos;
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_VCPatrol = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup west;
	// TODO CHANGE CLASSES to WEST
	"rhs_mvd_izlom_sergeant" createUnit [_pos, _grp];
	"rhs_mvd_izlom_arifleman" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman_LAT" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman" createUnit [_pos, _grp];
	"rhs_mvd_izlom_grenadier_rpg" createUnit [_pos, _grp];
	"rhs_mvd_izlom_rifleman_asval" createUnit [_pos, _grp];
	private _callsign = format ["GUE-%1", [] call ttt_fnc_getCallSign];
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_assaultLZ = {
	params ["_pos", "_heli"];

	waitUntil {sleep 0.1; _heli distance _pos < 1500};

	private _spawn = _pos getPos [500, random 360];
	private _squad = [_spawn] call ttt_fnc_VCPatrol;
	private _wp = _squad addWaypoint [_pos, 10];
	_wp setWaypointType "SAD";
	_squad setCombatMode "RED";
	_squad;
};

ttt_fnc_board = {
	params ["_grp", "_heli"];

	{_x assignAsCargo _heli} forEach units _grp;
	private _wp = _grp addWaypoint [(getPos _heli), 5];
	_wp setWaypointType "GETIN";
	waitUntil {{alive _x} count (units _grp) == {_x in _heli} count (units _grp)};
	(leader _grp) sideChat "All aboard";
	_grp;
};

ttt_fnc_disembark = {
	params ["_grp", "_heli"];
    {unassignVehicle _x} forEach units _grp;
    private _wp = _grp addWaypoint [(getPos _heli),15];
    _wp setWaypointType "GETOUT";
	 waitUntil {{alive _x} count (units _grp) == {!(_x in _heli)} count (units _grp)};
	(leader _grp) sideChat "Bye";
	[_grp, getPos (leader _grp), 1000] call BIS_fnc_taskPatrol;
	_grp;
};


ttt_fnc_getCallSign = {
	private _nr = floor random 100;
	private _base = selectRandom ttt_callsigns;

	format ["%1-%2", _base, _nr];
};

ttt_fnc_dispatchLZTeam = {
	params ["_pos", "_heli"];

	private _grp = createGroup east;
	"rhs_vmf_flora_officer" createUnit [_pos, _grp];
	"rhs_mvd_izlom_efreitor" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];

	waitUntil {sleep 0.1; _pos distance _heli < 1000};

	if (alive leader _grp) then {
		(leader _grp) sideChat "Dropping smoke";

		private _smoke = "SmokeShellPurple" createVehicle _pos;
		_smoke setPos [_pos select 0, _pos select 1, 5];
		_smoke setDamage 1;
	};
	true;
};

ttt_fnc_getRandomPos = {
	params ["_centerObject"];

	private _min = 2000;
	private _max = 5000;

	private _pos = [getPos _centerObject, _min, _max, 20, 0, 1, 0] call BIS_fnc_findSafePos;

	// need to find a position not too far away
	while {_pos distance Center > 10000} do {
		_pos = [getPos _centerObject, _min, _max, 20, 0, 1, 0] call BIS_fnc_findSafePos;
	};

	_pos;
};

ttt_fnc_baseLZ = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _destPos = [_orig] call ttt_fnc_getRandomPos;
	private _dest = "Land_HelipadEmpty_F" createVehicle _destPos;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarker ["orig", getPos _orig];
	_origMarker setMarkerType "hd_pickup";
	_origMarker setMarkerColor "ColorWhite";
	private _grp = [getPos _orig, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarker "orig";

	_heli vehicleChat "Fly to LZ marked on map";
	private _lzMarker = createMarker ["LZ", _destPos];
	_lzMarker setMarkerType "hd_objective";
	_lzMarker setMarkerColor "ColorWhite";
	[_destPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	waitUntil {sleep 1; _heli distance _dest < 50 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarker "LZ";
	_heli;
};

ttt_fnc_baseHotLZ = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _destPos = [_orig] call ttt_fnc_getRandomPos;
	private _dest = "Land_HelipadEmpty_F" createVehicle _destPos;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarker ["orig", getPos _orig];
	_origMarker setMarkerType "hd_pickup";
	_origMarker setMarkerColor "ColorWhite";
	private _grp = [getPos _orig, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarker "orig";

	_heli vehicleChat "Fly to LZ marked on map";
	private _lzMarker = createMarker ["LZ", _destPos];
	_lzMarker setMarkerType "hd_objective";
	_lzMarker setMarkerColor "ColorWhite";
	[_destPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	[_destPos, _heli] spawn ttt_fnc_assaultLZ;
	waitUntil {sleep 1; _heli distance _dest < 50 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarker "LZ";
	_heli;
};




ttt_fnc_baseBase = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _destBases = ttt_bases - [ _orig ];
	private _dest = selectRandom _destBases;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarker ["orig", getPos _orig];
	_origMarker setMarkerType "hd_pickup";
	_origMarker setMarkerColor "ColorWhite";
	private _grp = [getPos _orig, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarker "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarker ["LZ", getPos _dest];
	_lzMarker setMarkerType "hd_objective";
	_lzMarker setMarkerColor "ColorWhite";
	waitUntil {sleep 1; _heli distance _dest < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarker "LZ";
	_heli;
};

ttt_fnc_baseVillage = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _dest = selectRandom ttt_villages;
	private _destPos = getPos _dest;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarker ["orig", getPos _orig];
	_origMarker setMarkerType "hd_pickup";
	_origMarker setMarkerColor "ColorWhite";
	private _grp = [getPos _orig, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarker "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarker ["LZ", _destPos];
	_lzMarker setMarkerType "hd_objective";
	_lzMarker setMarkerColor "ColorWhite";
	[_destPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	waitUntil {sleep 1; _heli distance _dest < 50 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarker "LZ";
	_heli;
};

ttt_fnc_streetBase = {
	systemChat "No written yet";
};

ttt_fnc_baseStreet = {
	systemChat "No written yet";
};

ttt_fnc_LZBase = {
	params ["_heli"];

	private _dest = selectRandom ttt_bases;
	private _destPos = getPos _dest;
	private _origPos = [_dest] call ttt_fnc_getRandomPos;
	private _orig = "Land_HelipadEmpty_F" createVehicle _origPos;

	_heli vehicleChat format ["Fly to LZ, see map marker"];
	private _origMarker = createMarker ["orig", getPos _orig];
	_origMarker setMarkerType "hd_pickup";
	_origMarker setMarkerColor "ColorWhite";
	private _grp = [getPos _orig, _heli] call ttt_fnc_createPassengers;
	[_grp, _heli] spawn {
		params ["_grp", "_heli"];
		private _pos = getPos leader _grp;
		waitUntil {sleep 0.1; _pos distance _heli < 1000};

		(leader _grp) sideChat "Dropping smoke";

		private _smoke = "SmokeShellPurple" createVehicle _pos;
		_smoke setPos [_pos select 0, _pos select 1, 5];
		_smoke setDamage 1;
		_smoke;
	};
	waitUntil {sleep 1; _heli distance _orig < 100 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarker "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarker ["LZ", _destPos];
	_lzMarker setMarkerType "hd_objective";
	_lzMarker setMarkerColor "ColorWhite";
	waitUntil {sleep 1; _heli distance _dest < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarker "LZ";
	_heli;
};


ttt_fnc_initBase = {
	params ["_base"];
	// spawn some patrols and other people at the camps
	private _patrol = [getPos _base] call ttt_fnc_createSquad;
	[_patrol, getPos _base, 100] call BIS_fnc_taskPatrol;
	_patrol = [getPos _base] call ttt_fnc_createSquad;
	[_patrol, getPos _base, 100] call BIS_fnc_taskPatrol;

};


ttt_fnc_initBases = {
	{
		[_x] call ttt_fnc_initBase;
	} forEach ttt_bases;
};

ttt_fnc_planeTraffic = {
	params ["_spawn"];

	private _plane = createVehicle ["RHS_Su25SM_vvsc", _spawn, [], 500, "FLY"];
	createVehicleCrew _plane;
	{
		private _wp = (group driver _plane) addWaypoint [_x, 1000];
		_wp setWaypointType "MOVE";
	} forEach (ttt_bases call BIS_fnc_arrayShuffle);
	private _wp = (group driver _plane) addWaypoint [_spawn, 1000];
	_wp setWaypointType "CYCLE";
	_plane;
};

ttt_fnc_heloTraffic = {
	params ["_spawn"];
	private _type = selectRandom ["RHS_Ka52_vvsc", "rhs_ka60_c", "RHS_Mi24P_CAS_vvsc", "RHS_Mi24V_vvsc", "RHS_Mi8MTV3_vvsc"];
	private _helo = createVehicle [_type, _spawn, [], 100, "FLY"];
	createVehicleCrew _helo;
	{
		private _wp = (group driver _helo) addWaypoint [_x, 0];
		_wp setWaypointType "MOVE";
		private _pos = [_x] call ttt_fnc_getRandomPos;
		_wp = (group driver _helo) addWaypoint [_pos, 0];
		_wp setWaypointType "MOVE";
	} forEach (ttt_bases call BIS_fnc_arrayShuffle);
	private _wp = (group driver _helo) addWaypoint [Center, 100];
	_wp setWaypointType "MOVE";
	_helo;
};

ttt_fnc_airTraffic = {
	private _planes = [];
	private _helos = [];
	{
		private _plane = [_x] call ttt_fnc_planeTraffic;
		_planes pushBack _plane;
	} forEach ttt_spawnPoints + ttt_spawnPoints + ttt_spawnPoints;
	{
		private _helo = [_x] call ttt_fnc_heloTraffic;
		_helos pushBack _helo;
	} forEach ttt_bases + ttt_villages;
	{
		private _pos = Center getPos [200 + random 200, random 360];
		private _helo = [_pos] call ttt_fnc_heloTraffic;
		_helos pushBack _helo;
	} forEach [1, 2, 3, 4, 5, 6, 7, 8];

	ttt_aircraft = [_planes, _helos];
	ttt_aircraft;
};



ttt_fnc_opener = {
	waitUntil {sleep 0.1; !isNil "ttt_aircraft"};
	// plane or helo
	private _type = selectRandom [0,1];
	private _obj = selectRandom (ttt_aircraft select _type);
	private _pos = getPos _obj;
	_pos = [_pos select 0, _pos select 1, (_pos select 2) + 200];
	private _cam = "camera" camCreate _pos;
	_cam cameraEffect [ "internal", "back" ];
	_cam camSetFOV 0.7;

	private _i = 0;
	while {_i < 20} do {
		_cam camSetTarget _obj;
		_pos = _obj getPos [-50, getDir _obj];
		_pos = [_pos select 0, _pos select 1, (getPos _obj select 2) + 50];
		_cam camSetPos _pos;
		_cam camCommit 1;
		sleep 1;
		_i = _i + 1;
	};
	_cam cameraEffect [ "terminate", "back" ];
	camDestroy _cam;
	ttt_aircraft;
};


[] spawn {
	private _tasks = [ ttt_fnc_LZBase, ttt_fnc_baseStreet, ttt_fnc_streetBase, ttt_fnc_baseVillage, ttt_fnc_baseBase, ttt_fnc_baseLZ ];
	_tasks = [ ttt_fnc_baseLZ, ttt_fnc_baseBase, ttt_fnc_baseVillage, ttt_fnc_LZBase, ttt_fnc_baseHotLZ ];

	[] spawn ttt_fnc_initBases;
	[] spawn ttt_fnc_airTraffic;
	0 cutText ["Welcome to the North!", "BLACK IN", 15, false];
	waitUntil {alive player};
	[] spawn ttt_fnc_opener;
	sleep 20;

	systemChat "Initializing ...";
	sleep 1;
	Cmdr sideChat "Get out here - go do some flying!";
	sleep 5;

	waitUntil {sleep 1; vehicle player != player and (vehicle player) isKindOf "helicopter"};

	(vehicle player) vehicleChat "Welcome aboard! Tasking will start soon.";
	sleep 1;
	(vehicle player) vehicleChat "Boarding crew";
	createVehicleCrew (vehicle player);

	while {count _tasks > 0} do {
		private _task = selectRandom _tasks;
		_tasks = _tasks - [_task];

		[vehicle player] call _task;
		sleep 10;
	};
	Cmdr sideChat "All tasks completed, RTB!";
};